//////////////////////////////////////////////////
// Wars Button Klasse, zum anzeigen von buttons //
//////////////////////////////////////////////////

#include "StdHeaders.h"

button::button(int posX_L, int posX_R, int posY_T, int posY_B, char *mainpic, char *mouseover) : watcharea(posX_L, posX_R, posY_T, posY_B)
{
	no_mouseOver = 0;

	picture = load_bitmap(mainpic);
	if(!mouseover)
	{
		no_mouseOver = 1;
		mouseOver = picture;
	}
	else
		mouseOver = load_bitmap(mouseover);

	size_x = positions[1] - positions[0];
	size_y = positions[3] - positions[2];
};

button::~button()
{
		destroy_bitmap(picture);
		if(!no_mouseOver)
			destroy_bitmap(mouseOver);
};

void button::draw()
{
	BITMAP *curdraw = picture;
	if(mButton && area(positions[0], positions[1], positions[2], positions[3]))
		curdraw = mouseOver;

	blit(curdraw, doubleBuffer, positions[0], positions[2], size_x, size_y);
};


textbutton::textbutton(int posX_L, int posX_R, int posY_T, int posY_B, int textx, int texty, char *label, int tColor, int bColor) : watcharea(posX_L, posX_R, posY_T, posY_B)
{
	textX = textx;
	textY = texty;

	textcolor = tColor;
	boxcolor = bColor;

	text = label;
};

void textbutton::draw()
{
	rectfill(doubleBuffer, positions[0], positions[2], positions[1], positions[3], boxcolor);
	textout_centre(doubleBuffer, tahoma, text, textX, textY, textcolor);
};

watcharea::watcharea(int posX_L, int posX_R, int posY_T, int posY_B)
{
	positions[0] = posX_L;
	positions[1] = posX_R;
	positions[2] = posY_T;
	positions[3] = posY_B;
};

int watcharea::getstate()
{
	if(released && area(positions[0], positions[1], positions[2], positions[3]))
	{
		clickSound();
		return 1;
	};
	return 0;
};

void maskedbutton::draw()
{
	BITMAP *curdraw = picture;
	if(mButton && area(positions[0], positions[1], positions[2], positions[3]))
		curdraw = mouseOver;

	masked_blit(curdraw, doubleBuffer, 0, 0, positions[0], positions[2], size_x, size_y);
};

checkBox::checkBox(int posX_L, int posX_R, int posY_T, int posY_B, BITMAP *cross, int initialValue) : watcharea(posX_L, posX_R, posY_T, posY_B)
{
	this->cross = cross;
	checked = initialValue;

	size_x = positions[1] - positions[0];
	size_y = positions[3] - positions[2];
};

void checkBox::draw()
{
	if(checked)
		masked_blit(cross, doubleBuffer, 0, 0, positions[0], positions[2], size_x, size_y);
};

int checkBox::getstate()
{
	if(released && area(positions[0], positions[1], positions[2], positions[3]))
	{
		clickSound();
		checked ^= 1;
		return 1;
	};
	return 0;
};

void checkBox::setChecked(int value)
{
	checked = value;
};
