///////////////////////////////////
// Enthlt das eigentliche Spiel //
///////////////////////////////////

#include "StdHeaders.h"

#define STATE_MAP			0
#define STATE_MOVE			1
#define STATE_PRE_ATTACK	2
#define STATE_ATTACK		3
#define STATE_HITBACK		4
#define STATE_BUY_UNIT		5
#define STATE_ENDROUND		6

#define TILE_W 40
#define TILE_H 40
#define MAX_X Map.getMaxX()
#define MAX_Y Map.getMaxY()
#define MAP_W Map.getWidth()
#define MAP_H Map.getHeight()

#define actUnit units[curUnitTeam][curUnitIndex]

//Globale variablen
BITMAP *sprites[2][7];

//Einheitennamen Array
const char *names[7] = {
	"Militia",
	"Warrior",
	"Scout",
	"Cataphract",
	"Knight",
	"Catapult",
	"Trebuchet"
};


void changeView(int *viewx, int *viewy, int unitx, int unity, const int maxx, const int maxy)
{
	*viewx = unitx - 10;
	*viewy = unity - 5;
	if(*viewx < 0)
		*viewx = 0;
	if(*viewy < 0)
		*viewy = 0;
	if(*viewx > maxx)
		*viewx = maxx;
	if(*viewy > maxy)
		*viewy = maxy;
};

void game(char *mapName, int moneyPerHouse, char allowedUnits, int maxDays)
{
	mouseUpdate();

	//Statistik Variablen
	int moneySpent[2] = {0, 0},
		unitsBuilt[2] = {0, 0},
		unitsKilled[2] = {0, 0},
		damageInMoney[2] = {0, 0},
		fieldsMoved[2] = {0, 0},
		attacks[2] = {0, 0};
	int winner = -1;
	int fullPrice[7] = {1000, 3000, 3000, 7000, 16000, 6000, 15000};

	playlist pList;
	pList.play();

	//Lebensanzeige laden
	BITMAP *lifebar = load_bitmap("lifebar.tga"),
		*bigLifebar = load_bitmap("lifebarBig.tga");

	//Einheitenarray, enthlt alle Einheiten
	unit units[2][51];

	//Index fr for schleifen
	int a;

	for(a = 0; a < 2; ++a)
		for(int i = 0; i < 50; ++i)
			units[a][i].setBitmap(doubleBuffer);

	//Variablen fr den FPS Counter
	int frameCounter = 0, curFrames = 36, frameCountDown = 35;

	//Variable zum auswhlen einer neuen Einheit
	int unitSearch = 0;

	//Tastenstatus
	bool key_left = 0, key_right = 0, key_up = 0, key_down = 0, key_f = 0,
		key_v = 0, key_b = 0, key_n = 0, key_m = 0, key_u = 0, key_c = 0,
		key_a = 0, key_r = 0, key_cheat = 0;

	//Farben
	const int WHITE	 = makecol(255, 255, 255);
	const int BLUE	 = makecol(  0,   0, 200);
	const int RED	 = makecol(255,  50,  50);
	const int GREY	 = makecol(150, 150, 150);
	const int LBROWN = makecol(156, 103,   0);
	const int DBROWN = makecol( 99,  36,  16);

	//Buttons
	maskedbutton
		parkherebutton(370, 520, 450, 490, "park1.tga", "park2.tga"),
		attackbutton(370, 520, 500, 540, "attackbutton1.tga", "attackbutton2.tga"),
		noattackbutton(370, 520, 500, 540, "noattackbutton.tga"),
		movebutton(370, 520, 450, 490, "movebutton1.tga", "movebutton2.tga"),
		nomovebutton(370, 520, 450, 490, "nomovebutton.tga"),
		capturebutton(370, 520, 550, 590, "capture1.tga", "capture2.tga"),
		nocapturebutton(370, 520, 550, 590, "nocapture.tga"),
		endroundbutton(640, 790, 450, 490, "endround1.tga", "endround2.tga"),
		helpbutton(640, 790, 500, 540, "help1.tga", "help2.tga"),
		buybutton(370, 520, 450, 490, "buy1.tga", "buy2.tga"),
		cancelbutton(370, 520, 450, 490, "cancel1.tga", "cancel2.tga"),
		mainmenubutton(640, 790, 550, 590, "mainmenu1.tga", "mainmenu2.tga");

	//Watchareas
	watcharea
		mapbutton(0, 800, 0, 440),
		unitselectbutton(132, 240, 450, 588);

	//Momentan ausgewhltes Feld
	int curX = 0, curY = 0;
	//Rahmen ums Feld
	BITMAP *margin = load_bitmap("rahmen.tga");

	//Aktueller Status
	int state = STATE_MAP;

	//Momentan ausgewhlte Einheit
	int curUnitTeam = 0, curUnitIndex = 50;

	//Momentaner Sichtbereich
	int viewX = 0, viewY = 0;
	int oldViewX = viewX, oldViewY = viewY;

	//Runde
	int day = 1;

	//Infokasten
	BITMAP *info = load_bitmap("info.tga");

	//Tiles laden und Map erstellen
	BITMAP *tiles = load_bitmap("tiles.tga");
	map Map(mapName);
	Map.setTiles(tiles, TILE_W, TILE_H);
	Map.setTargetBitmap(doubleBuffer);

	//Aktuelles Guthaben beider Spieler
	int money[2] = { 0, 0 };
	Map.addMoney(&money[0], 0, moneyPerHouse);

	//Momentaner Spieler
	int curPlayer = 0;
	for(a = 0; a < MAP_H && viewX >= 0; ++a)
		for(int i = 0; i < MAP_W && viewX >= 0; ++i)
		{
			if(Map.getTileAt(i, a) == 23)
				changeView(&viewX, &viewY, i, a, MAX_X, MAX_Y);
			else if(Map.getTileAt(i, a) == 24)
				changeView(&oldViewX, &oldViewY, i, a, MAX_X, MAX_Y);
		};
	int curTile;

	//Kann die Einheit angreifen/ein Gebude einnehmen, bzw. muss dies berprft werden
	int isAbleToAttack = 0;
	int needsATAcheck = 1;
	int isAbleToCapture = 0;
	int needsATCcheck = 1;
	//ID der angegriffenen Einheit
	int attackedIndex = 50;
	//Schaden, der zugefgt wird
	float damage = 0.0;
	//Angriffsanimation
	int framecounter = 0;

	//Wenn exit positiv wird, keht man zum Hauptmen zurck
	int exit = 0;

	while(!exit)
	{
		while(timerCounter > 0)
		{
//////////////////////////////////////////////////////////////////////////////////////////
// Logik


			//Hauptmen
			//Esc zum Verlassen
			if(key[KEY_ESC] && !key_esc || mainmenubutton.getstate())
			{
				key_esc = 1;
				exit = yesno("Back to main menu?");
				if(exit)
					exit = 2;
			}
			else if(!key[KEY_ESC])
				key_esc = 0;
			//W zum wechseln zwischen fullscreen und windowed
			if(key[KEY_W])
				changemode(curmode);
			if(key[KEY_F] && !key_f)
			{
				key_f = 1;
				showFPS ^= 1;
			}
			else if(!key[KEY_F])
				key_f = 0;
			if(key[KEY_V] && !key_v)
			{
				key_v = 1;
				pList.play();
			}
			else if(!key[KEY_V])
				key_v = 0;
			if(key[KEY_B] && !key_b)
			{
				key_b = 1;
				pList.stop();
			}
			else if(!key[KEY_B])
				key_b = 0;
			if(key[KEY_N] && !key_n)
			{
				key_n = 1;
				pList.previous();
			}
			else if(!key[KEY_N])
				key_n = 0;
			if(key[KEY_M] && !key_m)
			{
				key_m = 1;
				pList.next();
			}
			else if(!key[KEY_M])
				key_m = 0;

			mouseUpdate();

			//Schauen, ob die Einheit angreifen kann
			if(needsATAcheck)
			{
				needsATAcheck = 0;
				isAbleToAttack = 0;
				if(actUnit.isAlife() && actUnit.canAttack() && (actUnit.getFriendfoe() == curPlayer))
				{
					int curUnitX, curUnitY;
					actUnit.getPos(&curUnitX, &curUnitY);
					//Wenn die Einheit Infanterie oder Kavallerie ist, die 4 umliegenden Felder checken
					if(actUnit.getGroup() == INFANTRY || actUnit.getGroup() == KAVALLRY)
					{
						for(int i = 0; i < 50; ++i)
						{
							if(!units[curPlayer ^ 1][i].isAlife())
								continue;
							int xPos, yPos;
							units[curPlayer ^ 1][i].getPos(&xPos, &yPos);
							if((curUnitX == xPos) && ((curUnitY + 1 == yPos) || (curUnitY - 1 == yPos)))
							{
								isAbleToAttack = 1;
								break;
							};
							if((curUnitY == yPos) && ((curUnitX + 1 == xPos) || (curUnitX - 1 == xPos)))
							{
								isAbleToAttack = 1;
								break;
							};
						};
					}
					else if(actUnit.getType() == 5) //Katapult
					{
						for(int i = 0; i < 50; ++i)
						{
							if(!units[curPlayer ^ 1][i].isAlife())
								continue;
							int xPos, yPos;
							units[curPlayer ^ 1][i].getPos(&xPos, &yPos);
							if((curUnitX == xPos) && ((curUnitY - 2 == yPos) || (curUnitY - 3 == yPos) || (curUnitY + 2 == yPos) || (curUnitY + 3 == yPos)))
							{
								isAbleToAttack = 1;
								break;
							};
							if((curUnitY == yPos) && ((curUnitX - 2 == xPos) || (curUnitX - 3 == xPos) || (curUnitX + 2 == xPos) || (curUnitX + 3 == xPos)))
							{
								isAbleToAttack = 1;
								break;
							};
							if(((curUnitX - 2 == xPos) || (curUnitX + 2 == xPos)) && ((curUnitY - 1 == yPos) || (curUnitY + 1 == yPos)))
							{
								isAbleToAttack = 1;
								break;
							};
							if(((curUnitX - 1 == xPos) || (curUnitX + 1 == xPos)) && ((curUnitY - 1 == yPos) || (curUnitY - 2 == yPos) || (curUnitY + 1 == yPos) || (curUnitY + 2 == yPos)))
							{
								isAbleToAttack = 1;
								break;
							};
						}
					}
					else if(actUnit.getType() == 6) //Trebuchet
					{
						for(int i = 0; i < 50; ++i)
						{
							if(!units[curPlayer ^ 1][i].isAlife())
								continue;
							int xPos, yPos;
							units[curPlayer ^ 1][i].getPos(&xPos, &yPos);
							if((curUnitX == xPos) && ((curUnitY - 5 == yPos) || (curUnitY - 4 == yPos) || (curUnitY - 3 == yPos) ||
								(curUnitY + 5 == yPos) || (curUnitY + 4 == yPos) || (curUnitY + 3 == yPos)))
							{
								isAbleToAttack = 1;
								break;
							};
							if((curUnitY == yPos) && ((curUnitX - 5 == xPos) || (curUnitX - 4 == xPos) || (curUnitX - 3 == xPos) ||
								(curUnitX + 5 == xPos) || (curUnitX + 4 == xPos) || (curUnitX + 3 == xPos)))
							{
								isAbleToAttack = 1;
								break;
							};
							if(((curUnitX - 2 == xPos) || (curUnitX + 2 == xPos)) &&
								((curUnitY - 3 == yPos) || (curUnitY - 2 == yPos) || (curUnitY - 1 == yPos) ||
								(curUnitY + 3 == yPos) || (curUnitY + 2 == yPos) || (curUnitY + 1 == yPos)))
							{
								isAbleToAttack = 1;
								break;
							};
							if(((curUnitX - 1 == xPos) || (curUnitX + 1 == xPos)) &&
								((curUnitY - 4 == yPos) || (curUnitY - 3 == yPos) || (curUnitY - 2 == yPos) ||
								(curUnitY + 4 == yPos) || (curUnitY + 3 == yPos) || (curUnitY + 2 == yPos)))
							{
								isAbleToAttack = 1;
								break;
							};
							if(((curUnitX - 4 == xPos) || (curUnitX + 4 == xPos)) && ((curUnitY - 1 == yPos) || (curUnitY + 1 == yPos)))
							{
								isAbleToAttack = 1;
								break;
							};
							if(((curUnitX - 3 == xPos) || (curUnitX + 3 == xPos)) && ((curUnitY - 2 == yPos) || (curUnitY - 1 == yPos) || (curUnitY + 1 == yPos) || (curUnitY + 2 == yPos)))
							{
								isAbleToAttack = 1;
								break;
							};
						};
					};
				};
			};
			//Gebude einnehmen
			if(needsATCcheck)
			{
				needsATCcheck = 0;
				isAbleToCapture = 0;
				if(actUnit.isAlife()
					&& curUnitTeam == curPlayer
					&& actUnit.getGroup() == INFANTRY
					&& actUnit.getMovePoints() == moveType[actUnit.getType()]
					&& (curTile == 16 || curTile == 18 - curPlayer || curTile == 19
					|| curTile == 21 - curPlayer || curTile == 24 - curPlayer))
				{
					isAbleToCapture = 1;
				};
			};
			//Hilfe
			if(helpbutton.getstate() || key[KEY_F1])
			{
				if(!helppage1)
				{
					helppage1 = create_bitmap();
					helppage2 = create_bitmap();

					blit(multiBG, helppage1);
					blit(multiBG, helppage2);

					BITMAP *helpBuffer = load_bitmap("helppage1.tga");
					blit(helpBuffer, helppage1, 59, 74, 690, 482);
					destroy_bitmap(helpBuffer);
					helpBuffer = load_bitmap("helppage2.tga");
					blit(helpBuffer, helppage2, 35, 75, 678, 481);
					destroy_bitmap(helpBuffer);
				};
				title(helppage1, 18, 0);
				title(helppage2, 32, 0);
			};
			curTile = Map.getTileAt(curX, curY);

			switch(state)
			{
		////// Einheiten/Gebude auswhlen
			case STATE_MAP:
				//Scrollen ber die Karte per Richtungspfeile,
				//(wenn shift nicht gedrckt ist)
				//if(!key[KEY_LSHIFT])
				//{
				//Runterscrollen
				if((mouse_y >= 594 || key[KEY_DOWN]) && !key_down && viewY < Map.getMaxY())
				{
					++viewY;
					key_down ^= 1;
				}
				else if(key_down)
					key_down ^= 1;
				//Hochscrollen
				if((mouse_y <= 5 || key[KEY_UP]) && !key_up && viewY > 0)
				{
					--viewY;
					key_up ^= 1;
				}
				else if(key_up)
					key_up ^= 1;
				//Rechts scrollen
				if((mouse_x >= 794 || key[KEY_RIGHT]) && !key_right && viewX < Map.getMaxX())
				{
					++viewX;
					key_right ^= 1;
				}
				else if(key_right)
					key_right ^= 1;
				//Links scrollen
				if(!key_left && (mouse_x <= 5 || key[KEY_LEFT]) && viewX > 0)
				{
					key_left ^= 1;
					--viewX;
				}
				else if(key_left)
					key_left ^= 1;
				//}
				//Wenn shift gedrckt ist, wird der Auswahlcursor bewegt
				//else
				//{
				//};

				//Wurde auf die map geklickt?
				if(mapbutton.getstate())
				{
					int newUnit = 0;
					curX = mouse_x / TILE_W + viewX;
					curY = mouse_y / TILE_H + viewY;
					for(int a = 0; a < 2; ++a)
					{
						for(int i = 0; i < 50; ++i)
						{
							if(!units[a][i].isAlife())
								continue;
							int x, y;
							units[a][i].getPos(&x, &y);
							if(x == curX && y == curY)
							{
								curUnitTeam = a;
								curUnitIndex = i;
								newUnit = 1;
								break;
							};
						};
						if(newUnit)
							break;
						else
						{
							curUnitTeam = 0;
							curUnitIndex = 50;
						};
					};
					needsATAcheck = 1;
					needsATCcheck = 1;
					curTile = Map.getTileAt(curX, curY);
				};
				//Neue Einheit auswhlen
				if((!actUnit.isAlife()) && unitselectbutton.getstate() || key[KEY_U] && !key_u)
				{
					if(key[KEY_U])
						key_u = 1;
					bool success = 0;
					int startedFrom = unitSearch;
					while(true)
					{
						if(units[curPlayer][unitSearch].getMovePoints() > 0)
						{
							curUnitTeam = curPlayer;
							curUnitIndex = unitSearch;
							actUnit.getPos(&curX, &curY);
							success = 1;
							needsATAcheck = 1;
							needsATCcheck = 1;
							++unitSearch;
							break;
						}
						else
						{
							++unitSearch;
							if(unitSearch >= 50)
								unitSearch = 0;
							if(startedFrom == unitSearch)
								break;
						};
					};
					if(!success)
						msgBox("No unit availible.");
					else
						changeView(&viewX, &viewY, curX, curY, MAX_X, MAX_Y);
				}
				else if(!key[KEY_U])
					key_u = 0;
				//Zum PRE_ATTACK Modus wechseln
				if(isAbleToAttack && (attackbutton.getstate() || key[KEY_A] && !key_a))
				{
					state = STATE_PRE_ATTACK;
					key_a = 1;
				}
				else if(!key[KEY_A])
					key_a = 0;
				//Gebude einnehmen
				if(isAbleToCapture && (capturebutton.getstate() || key[KEY_C] && !key_c))
				{
					actUnit.attack();
					actUnit.killMovePoints();
					if(curTile > 22)
					{
						exit = 1;
						winner = curPlayer;
					}
					else if(curTile > 18)
						Map.setTileAt(actUnit.getX(), actUnit.getY(), 20 + curPlayer);
					else
						Map.setTileAt(actUnit.getX(), actUnit.getY(), 17 + curPlayer);
					needsATCcheck = 1;
					key_c = 1;
				}
				else if(!key[KEY_C])
					key_c = 0;
				//Wechseln zum Bewegungsmodus wenn Button geklickt wurde
				if(actUnit.isAlife() && curUnitTeam == curPlayer
					&& actUnit.getMovePoints()
					&& (movebutton.getstate() || key[KEY_ENTER] && !key_enter))
				{
					state = STATE_MOVE;
					key_enter = 1;
				}
				else if(!key[KEY_ENTER])
					key_enter = 0;

				if(curTile == 20 + curPlayer && (buybutton.getstate() || key[KEY_ENTER] && !key_enter) && !actUnit.isAlife())
				{
					state = STATE_BUY_UNIT;
					key_enter = 1;
				}
				else if(!key[KEY_ENTER])
					key_enter = 0;
				//Runde beenden
				if(endroundbutton.getstate() || (key[KEY_R] && !key_r))
				{
					state = STATE_ENDROUND;
					key_r = 1;
				}
				else if(!key[KEY_R])
					key_r = 0;

/////////////////////////////////////////////////////////////////////////
///////////////////////////////////////CHEATS////////////////////////////
/////////////////////////////////////////////////////////////////////////
				//1000$
				if(key[KEY_F12] && key[KEY_LSHIFT] && key[KEY_LCONTROL] && !key_cheat)
				{
					money[curPlayer] += 1000;
					key_cheat = 1;
				};
				//Ritter
				if(key[KEY_F11] && key[KEY_LSHIFT] && key[KEY_LCONTROL] && !key_cheat && !actUnit.isAlife())
				{
					int unitIndex = -1;
					for(int i = 0; i < 50; ++i)
						if(!units[curPlayer][i].isAlife())
							unitIndex = i;
					if(unitIndex < 0)
						msgBox("You reached the maximum of 50 units per player.");
					units[curPlayer][unitIndex].initialise(curX, curY, 4, curPlayer);
					curUnitTeam = curPlayer;
					curUnitIndex = unitIndex;
					key_cheat = 1;
				};
				//Trebuchet
				if(key[KEY_F10] && key[KEY_LSHIFT] && key[KEY_LCONTROL] && !key_cheat && !actUnit.isAlife())
				{
					int unitIndex = -1;
					for(int i = 0; i < 50; ++i)
						if(!units[curPlayer][i].isAlife())
							unitIndex = i;
					if(unitIndex < 0)
						msgBox("You reached the maximum of 50 units per player.");
					units[curPlayer][unitIndex].initialise(curX, curY, 6, curPlayer);
					curUnitTeam = curPlayer;
					curUnitIndex = unitIndex;
					key_cheat = 1;
				};
				if(!key[KEY_F12] && !key[KEY_F11] && !key[KEY_F10] && !key[KEY_LSHIFT] && !key[KEY_LCONTROL])
					key_cheat = 0;
/////////////////////////////////////////////////////////////////////////
////////////////////////////////////CHEATS ENDE//////////////////////////
/////////////////////////////////////////////////////////////////////////

				break;
		////// Einheit bewegen
			case STATE_MOVE:
				int xbuf, ybuf;
				actUnit.getPos(&xbuf, &ybuf);
				//Einheit nach rechts bewegen
				if(key[KEY_RIGHT] && !key_right)
				{
					int move = Map.isWalkable(xbuf + 1, ybuf, actUnit.getGroup());	
					if(move > 0 && actUnit.getMovePoints() >= move)
					{
						int blocked = 0;
						for(int a = 0; a < 2 && !blocked; ++a)
							for(int i = 0; i < 50 && !blocked; ++i)
								if(units[a][i].getX() == xbuf + 1 && units[a][i].getY() == ybuf)
									blocked = 1;
						if(!blocked)
						{
							++xbuf;
							actUnit.setPos(xbuf, ybuf);
							actUnit.substractMovePoints(move);
							curX = xbuf;
							curTile = Map.getTileAt(curX, curY);
							if(actUnit.getGroup() == ARTILLRY)
								actUnit.attack();
							++fieldsMoved[curPlayer];
						};
					};
					key_right ^= 1;
					needsATAcheck = 1;
					needsATCcheck = 1;
				}
				else if(key_right && !key[KEY_RIGHT])
					key_right ^= 1;
				//Einheit nach unten bewegen
				if(key[KEY_DOWN] && !key_down)
				{
					int move = Map.isWalkable(xbuf, ybuf + 1, actUnit.getGroup());
					if(move > 0 && actUnit.getMovePoints() >= move)
					{
						int blocked = 0;
						for(int a = 0; a < 2 && !blocked; ++a)
							for(int i = 0; i < 50 && !blocked; ++i)
								if(units[a][i].getY() == ybuf + 1 && units[a][i].getX() == xbuf)
									blocked = 1;
						if(!blocked)
						{
							++ybuf;
							actUnit.setPos(xbuf, ybuf);
							actUnit.substractMovePoints(move);
							curY = ybuf;
							curTile = Map.getTileAt(curX, curY);
							if(actUnit.getGroup() == ARTILLRY)
								actUnit.attack();
							++fieldsMoved[curPlayer];
						};
					};
					key_down ^= 1;
					needsATAcheck = 1;
					needsATCcheck = 1;
				}
				else if(key_down && !key[KEY_DOWN])
					key_down ^= 1;
				//Einheit nach links bewegen
				if(key[KEY_LEFT] && !key_left)
				{
					int move = Map.isWalkable(xbuf - 1, ybuf, actUnit.getGroup());	
					if(move > 0 && actUnit.getMovePoints() >= move)
					{
						int blocked = 0;
						for(int a = 0; a < 2 && !blocked; ++a)
							for(int i = 0; i < 50 && !blocked; ++i)
								if(units[a][i].getX() == xbuf - 1 && units[a][i].getY() == ybuf)
									blocked = 1;
						if(!blocked)
						{
							--xbuf;
							actUnit.setPos(xbuf, ybuf);
							actUnit.substractMovePoints(move);
							curX = xbuf;
							curTile = Map.getTileAt(curX, curY);
							if(actUnit.getGroup() == ARTILLRY)
								actUnit.attack();
							++fieldsMoved[curPlayer];
						};
					};
					key_left ^= 1;
					needsATAcheck = 1;
					needsATCcheck = 1;
				}
				else if(key_left && !key[KEY_LEFT])
					key_left ^= 1;
				//Einheit nach oben bewegen
				if(key[KEY_UP] && !key_up)
				{
					int move = Map.isWalkable(xbuf, ybuf - 1, actUnit.getGroup());	
					if(move > 0 && actUnit.getMovePoints() >= move)
					{
						int blocked = 0;
						for(int a = 0; a < 2 && !blocked; ++a)
							for(int i = 0; i < 50 && !blocked; ++i)
								if(units[a][i].getY() == ybuf - 1 && units[a][i].getX() == xbuf)
									blocked = 1;
						if(!blocked)
						{
							--ybuf;
							actUnit.setPos(xbuf, ybuf);
							actUnit.substractMovePoints(move);
							curY = ybuf;
							curTile = Map.getTileAt(curX, curY);
							if(actUnit.getGroup() == ARTILLRY)
								actUnit.attack();
							++fieldsMoved[curPlayer];
						};
					};
					key_up ^= 1;
					needsATAcheck = 1;
					needsATCcheck = 1;
				}
				else if(key_up && !key[KEY_UP])
					key_up ^= 1;
				//Zurck zur Karte
				if(parkherebutton.getstate() || key[KEY_ENTER] && !key_enter)
				{
					key_enter = 1;
					state = STATE_MAP;
				}
				else if(!key[KEY_ENTER])
					key_enter = 0;

				//Einheit in die Mitte des Bildschirms holen
				changeView(&viewX, &viewY, xbuf, ybuf, MAX_X, MAX_Y);

				//Wenn die Einheit sich nicht mehr bewegen kann, zur Karte wechseln
				int movePointBuffer;
				if(    (((movePointBuffer = Map.isWalkable(actUnit.getX() + 1, actUnit.getY(), actUnit.getGroup())) > actUnit.getMovePoints()) || !movePointBuffer)
					&& (((movePointBuffer = Map.isWalkable(actUnit.getX() - 1, actUnit.getY(), actUnit.getGroup())) > actUnit.getMovePoints()) || !movePointBuffer)
					&& (((movePointBuffer = Map.isWalkable(actUnit.getX(), actUnit.getY() + 1, actUnit.getGroup())) > actUnit.getMovePoints()) || !movePointBuffer)
					&& (((movePointBuffer = Map.isWalkable(actUnit.getX(), actUnit.getY() - 1, actUnit.getGroup())) > actUnit.getMovePoints()) || !movePointBuffer)
					)
				{
					actUnit.killMovePoints();
				};

				if(!actUnit.getMovePoints())
				{
					state = STATE_MAP;
				};
				//Zum PRE_ATTACK Modus wechseln
				if(isAbleToAttack && (attackbutton.getstate() || key[KEY_A] && !key_a))
				{
					state = STATE_PRE_ATTACK;
					key_a = 1;
				}
				else if(!key[KEY_A])
					key_a = 0;
				break;
		////// Einheit auswhlen, die angegriffen werden soll
			case STATE_PRE_ATTACK:
				//Einheit in die Mitte des Bildschirms holen
				changeView(&viewX, &viewY, actUnit.getX(), actUnit.getY(), MAX_X, MAX_Y);

				if(cancelbutton.getstate() || (key[KEY_ENTER] && !key_enter))
				{
					state = STATE_MAP;
					key_enter = 1;
				}
				else if(!key[KEY_ENTER])
					key_enter = 0;
				if(mapbutton.getstate())
				{
					int newUnit = 0;
					int error = 0;
					int attackedX = mouse_x / TILE_W + viewX;
					int attackedY = mouse_y / TILE_H + viewY;
					int enemyTeam = curUnitTeam ^ 1;
					for(int i = 0; i < 50; ++i)
					{
						int x, y;
						units[enemyTeam][i].getPos(&x, &y);
						if(x == attackedX && y == attackedY)
						{
							if(actUnit.getGroup() == INFANTRY || actUnit.getGroup() == KAVALLRY)
							{
								if((curX == attackedX && (curY == attackedY + 1 || curY == attackedY - 1))
									|| (curY == attackedY && (curX == attackedX + 1 || curX == attackedX - 1)))
								{
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
							}
							else if(actUnit.getType() == 5) //Katapult
							{
								if((curX == attackedX) && ((curY - 2 == attackedY) || (curY - 3 == attackedY) || (curY + 2 == attackedY) || (curY + 3 == attackedY)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
								if((curY == attackedY) && ((curX - 2 == attackedX) || (curX - 3 == attackedX) || (curX + 2 == attackedX) || (curX + 3 == attackedX)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
								if(((curX - 2 == attackedX) || (curX + 2 == attackedX)) && ((curY - 1 == attackedY) || (curY + 1 == attackedY)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
								if(((curX - 1 == attackedX) || (curX + 1 == attackedX)) && ((curY - 1 == attackedY) || (curY - 2 == attackedY) || (curY + 1 == attackedY) || (curY + 2 == attackedY)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
							}
							else if(actUnit.getType() == 6) //Trebuchet
							{
								if((curX == attackedX) && ((curY - 5 == attackedY) || (curY - 4 == attackedY) || (curY - 3 == attackedY) ||
									(curY + 5 == attackedY) || (curY + 4 == attackedY) || (curY + 3 == attackedY)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
								if((curY == attackedY) && ((curX - 5 == attackedX) || (curX - 4 == attackedX) || (curX - 3 == attackedX) ||
									(curX + 5 == attackedX) || (curX + 4 == attackedX) || (curX + 3 == attackedX)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
								if(((curX - 2 == attackedX) || (curX + 2 == attackedX)) &&
									
									((curY - 3 == attackedY) || (curY - 2 == attackedY) || (curY - 1 == attackedY) ||
									(curY + 3 == attackedY) || (curY + 2 == attackedY) || (curY + 1 == attackedY)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
								if(((curX - 1 == attackedX) || (curX + 1 == attackedX)) &&
									((curY - 4 == attackedY) || (curY - 3 == attackedY) || (curY - 2 == attackedY) ||
									(curY + 4 == attackedY) || (curY + 3 == attackedY) || (curY + 2 == attackedY)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
								if(((curX - 4 == attackedX) || (curX + 4 == attackedX)) && ((curY - 1 == attackedY) || (curY + 1 == attackedY)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
								if(((curX - 3 == attackedX) || (curX + 3 == attackedX)) && ((curY - 2 == attackedY) || (curY - 1 == attackedY) || (curY + 1 == attackedY) || (curY + 2 == attackedY)))
								{
									error = 0;
									attackedIndex = i;
									newUnit = 1;
									break;
								}
								else
									error = 1;
							};
						};
					};
					if(newUnit)
						state = STATE_ATTACK;
					else if(error)
						msgBox("You can't attack this unit.");
				};
				break;

		////// Schaden zufgen
			case STATE_ATTACK:
				if(!damage)
				{
					damage = damageType[actUnit.getType()][units[curUnitTeam ^ 1][attackedIndex].getType()];
					float mod1 = (float)actUnit.getLife() / 100.0;
					float mod2 = 1.0 - (float)units[curUnitTeam ^ 1][attackedIndex].getLife() * (float)Map.getDefense(units[curUnitTeam ^ 1][attackedIndex].getX(), units[curUnitTeam ^ 1][attackedIndex].getY()) / 1000.0;
					damage *= mod1 * mod2;
					char textBuffer[32];
					sprintf(textBuffer,"You will do %i damage. Attack?", (int)damage);
					if(!yesno(textBuffer))
					{
						state = STATE_PRE_ATTACK;
						damage = 0.0;
						break;
					};
				};
				if(framecounter < (int) damage * 2 && units[curUnitTeam ^ 1][attackedIndex].isAlife())
				{
					if(framecounter & 1)
							units[curUnitTeam ^ 1][attackedIndex].substractLife(1);
					++framecounter;
				}
				else
				{
					actUnit.attack();
					actUnit.killMovePoints();
					framecounter = 0;
					state = STATE_HITBACK;
					needsATAcheck = 1;
					if(actUnit.getGroup() == ARTILLRY || units[curUnitTeam ^ 1][attackedIndex].getGroup() == ARTILLRY || !units[curUnitTeam ^ 1][attackedIndex].isAlife())
					{
						if(!units[curUnitTeam ^ 1][attackedIndex].isAlife())
							++unitsKilled[curPlayer];
						state = STATE_MAP;
					};
					++attacks[curPlayer];
					damageInMoney[curPlayer] += fullPrice[units[curUnitTeam ^ 1][attackedIndex].getType()] * (int) damage / 100;
					damage = 0.0;
				};
				break;

		////// Zurckschlagen
			case STATE_HITBACK:
				if(!damage)
				{
					damage = damageType[units[curUnitTeam ^ 1][attackedIndex].getType()][actUnit.getType()];
					float mod1 = (float)units[curUnitTeam ^ 1][attackedIndex].getLife() / 100.0;
					float mod2 = 1.0 - (float)actUnit.getLife() * (float)Map.getDefense(curX, curY) / 1000.0;
					damage *= mod1 * mod2;
				};
				if(framecounter < (int) damage * 2 && actUnit.isAlife())
				{
					if(framecounter & 1)
						actUnit.substractLife(1);
					++framecounter;
				}
				else
				{
					if(!actUnit.isAlife())
							++unitsKilled[curPlayer ^ 1];
					damageInMoney[curPlayer ^ 1] += fullPrice[actUnit.getType()] * (int) damage / 100;
					damage = 0.0;
					framecounter = 0;
					state = STATE_MAP;
				};
				break;
		////// Einheit einkaufen
			case STATE_BUY_UNIT:
				{
				int unitIndex = -1;
				for(int i = 0; i < 50; ++i)
					if(!units[curPlayer][i].isAlife())
					{
						unitIndex = i;
						break;
					};
				if(unitIndex < 0)
				{
					msgBox("You reached the maximum of 50 units per player.");
					state = STATE_MAP;
					break;
				};
				int value = buyUnit(&money[curPlayer], curPlayer, margin, allowedUnits, &moneySpent[curPlayer]);
				if(value >= 0)
				{
					units[curPlayer][unitIndex].initialise(curX, curY, value, curPlayer);
					curUnitTeam = curPlayer;
					curUnitIndex = unitIndex;
					state = STATE_MAP;

					++unitsBuilt[curPlayer];
				}
				else
					state = STATE_MAP;
				}
				break;
		////// Runde beenden und Spieler wechseln
			case STATE_ENDROUND:
				//Ansicht tauschen
				viewX^=oldViewX^=viewX^=oldViewX;
				viewY^=oldViewY^=viewY^=oldViewY;
				if(curPlayer)
					++day;
				if(maxDays && day > maxDays)
				{
					msgBox("There was no winner in this war.");
					exit = 1;
				};
				curPlayer ^= 1;
				Map.addMoney(&money[curPlayer], curPlayer, moneyPerHouse);
				int prices[7] = { 200, 600, 600, 1400, 3200, 1200, 3000 };
				for(int i = 0; i < 50; ++i)
				{
					units[curPlayer][i].endRound();
					int checkTile = Map.getTileAt(units[curPlayer][i].getX(), units[curPlayer][i].getY());
					if(units[curPlayer][i].isAlife() && units[curPlayer][i].getLife() < 100 && (checkTile == 17 + curPlayer || checkTile == 20 + curPlayer || checkTile == 23 + curPlayer) && money[curPlayer] >= prices[units[curPlayer][i].getType()])
					{
						if(units[curPlayer][i].getLife() <= 80)
						{
							units[curPlayer][i].addLife(20);
							money[curPlayer] -= prices[units[curPlayer][i].getType()];
							moneySpent[curPlayer] += prices[units[curPlayer][i].getType()];
						}
						else
						{
							int missing = 100 - units[curPlayer][i].getLife();
							units[curPlayer][i].addLife(missing);
							money[curPlayer] -= prices[units[curPlayer][i].getType()] / 20 * missing;
							moneySpent[curPlayer] += prices[units[curPlayer][i].getType()] / 20 * missing;
						};
					};
				};
				needsATAcheck = 1;
				needsATCcheck = 1;

				state = STATE_MAP;
				break;
			};

			if(frameCountDown <= 0)
			{
				frameCountDown = 35 + frameCountDown;
				curFrames = frameCounter;
				frameCounter = 0;

				pList.check();
			}
			else
				--frameCountDown;

			--timerCounter;
			if(timerCounter >= 1)
			{
				frameCountDown -= timerCounter;
				timerCounter = 0;
			}
		};
//////////////////////////////////////////////////////////////////////////////////////////
// Grafik

		//Karte zeichnen
		Map.draw(viewX, viewY);

		//Einheiten zeichnen
		for(int a = 0; a < 2; ++a)
			for(int i = 0; i < 50; ++i)
				units[a][i].draw(viewX, viewY, TILE_H, TILE_W);

		//Infokasten anzeigen
		blit(info, doubleBuffer, 0, 440, 800, 160);

		//Feld Infos
		textprintf(doubleBuffer, tahoma, 20, 460, DBROWN, "%s", Map.getName(curX, curY));
		textprintf(doubleBuffer, tahoma, 20, 480, DBROWN, "%i Def.", Map.getDefense(curX, curY));
		textprintf(doubleBuffer, tahoma, 20, 500, DBROWN, "Pos.: %i/%i", curX+1, curY+1);
		if(curTile > 15 && curTile != 22)
		{
			if(curTile == 16 || curTile == 19)
				textout(doubleBuffer, tahoma, "Neutral", 20, 520, GREY);
			else if(curTile == 17 || curTile == 20 || curTile == 23)
				textout(doubleBuffer, tahoma, "Red", 20, 520, RED);
			else if(curTile == 18 || curTile == 21 || curTile == 24)
				textout(doubleBuffer, tahoma, "Blue", 20, 520, BLUE);
		};

		//Einheit Infos
		if(actUnit.isAlife())
		{
			textprintf(doubleBuffer, tahoma, 140, 460, DBROWN, "%s", names[actUnit.getType()]);
			textprintf(doubleBuffer, tahoma, 140, 480, DBROWN, "%i Life", actUnit.getLife());
			if(actUnit.getFriendfoe())
				textout(doubleBuffer, tahoma, "Blue", 140, 500, BLUE);
			else
				textout(doubleBuffer, tahoma, "Red", 140, 500, RED);
			textprintf(doubleBuffer, tahoma, 140, 520, DBROWN, "%i Movepoints", actUnit.getMovePoints());
			blit(bigLifebar, doubleBuffer, 135, 575, actUnit.getLife(), 10);
		}
		else
		{
			textout(doubleBuffer, tahoma, "Click here", 140, 480, DBROWN);
			textout(doubleBuffer, tahoma, "to select a", 140, 500, DBROWN);
			textout(doubleBuffer, tahoma, "unit who", 140, 520, DBROWN);
			textout(doubleBuffer, tahoma, "can move.", 140, 540, DBROWN);
		};

		//Spieler Infos
		if(curPlayer)
		{
			textout(doubleBuffer, tahoma, "Player2's turn", 255, 455, BLUE);
			textprintf(doubleBuffer, tahoma, 255, 475, BLUE, "%i$", money[curPlayer]);
			textprintf(doubleBuffer, tahoma, 255, 495, BLUE, "Day %i", day);
			if(maxDays)
				textprintf(doubleBuffer, tahoma, 255, 515, BLUE, "%i days left", maxDays - day);
		}
		else
		{
			textout(doubleBuffer, tahoma, "Player1's turn", 255, 455, RED);
			textprintf(doubleBuffer, tahoma, 255, 475, RED, "%i$", money[curPlayer]);
			textprintf(doubleBuffer, tahoma, 255, 495, RED, "Day %i", day);
			if(maxDays)
				textprintf(doubleBuffer, tahoma, 255, 515, RED, "%i days left", maxDays - day);
		};
		textprintf(doubleBuffer, tahoma, 255, 550, DBROWN, "Song %i", pList.getCurTitle() + 1);
		if(showFPS)
			textprintf(doubleBuffer, tahoma, 255, 570, DBROWN, "%i fps", curFrames);

		//Kontextsensitive Infos
		switch(state)
		{
		case STATE_MAP:
			if(actUnit.isAlife() && actUnit.getFriendfoe() == curPlayer)
			{
				if(actUnit.getMovePoints())
					movebutton.draw();
				else
					nomovebutton.draw();
				if(isAbleToAttack)
					attackbutton.draw();
				else
					noattackbutton.draw();
			};
			endroundbutton.draw();
			if(curX >= viewX && curX <= viewX + 19 && curY >= viewY && curY <= viewY + 10)
			{
				masked_blit(margin, doubleBuffer, 0, 0, (curX - viewX) * TILE_W, (curY - viewY) * TILE_H, TILE_W, TILE_H);
				if(actUnit.isAlife())
					actUnit.drawLife(viewX, viewY, TILE_H, TILE_W, lifebar);
			};
			if(isAbleToCapture)
				capturebutton.draw();
			else if(actUnit.isAlife()
				&& actUnit.getGroup() == INFANTRY
				&& curUnitTeam == curPlayer)
				nocapturebutton.draw();
			if(curTile == 20 + curPlayer && !actUnit.isAlife())
				buybutton.draw();
			break;

		case STATE_MOVE:
			parkherebutton.draw();
			if(isAbleToAttack)
				attackbutton.draw();
			else
				noattackbutton.draw();

			textout(doubleBuffer, tahoma, "Use arrow keys to move.", 370, 545, LBROWN);

			break;
		case STATE_PRE_ATTACK:
			cancelbutton.draw();
			textout(doubleBuffer, tahoma, "Select a unit to attack.", 370, 500, LBROWN);
			//Lebensbalken zeichnen
			for(a = 0; a < 2; ++a)
				for(int i = 0; i < 50; ++i)
					units[a][i].drawLife(viewX, viewY, TILE_H, TILE_W, lifebar);			
			break;
		case STATE_ATTACK:
			//Lebensbalken zeichnen
			actUnit.drawLife(viewX, viewY, TILE_H, TILE_W, lifebar);
			units[curPlayer ^ 1][attackedIndex].drawLife(viewX, viewY, TILE_H, TILE_W, lifebar);

			textprintf(doubleBuffer, tahoma, 140, 480, DBROWN, "%i Life", actUnit.getLife());
			textprintf(doubleBuffer, tahoma, 370, 500, LBROWN, "You're inflicting %i damage.", (int)damage);
			break;
		case STATE_HITBACK:
			//Lebensbalken zeichnen
			actUnit.drawLife(viewX, viewY, TILE_H, TILE_W, lifebar);
			units[curPlayer ^ 1][attackedIndex].drawLife(viewX, viewY, TILE_H, TILE_W, lifebar);
			textprintf(doubleBuffer, tahoma, 370, 500, LBROWN, "The enemy is inflicting %i damage.", (int)damage);
			break;
		};

		//hauptbuttons
		helpbutton.draw();
		mainmenubutton.draw();

		//Mauszeiger anzeigen
		mouseblit();
		//doubleBuffer auf den Bildschirm bertragen
		show();
		++frameCounter;
	};
	//Die Statistik soll immer angezeigt werden
#if 0
	if(exit < 2)
	{
#endif
		//Statistik und Gewinnerbild anzeigen
		BITMAP *victory = create_bitmap();
		blit(multiBG, victory);
		if(winner < 0)
		{
			if(damageInMoney[0] > damageInMoney[1])
				winner = 0;
			else
				winner = 1;
		};
		if(winner)
			textout_centre(victory, tahoma, "The blue player won this war!", 400, 80, BLUE);
		else
			textout_centre(victory, tahoma, "The red player won this war!", 400, 80, RED);
		textout_centre(victory, tahoma, "Red Player", 400, 150, RED);
		textout_centre(victory, tahoma, "Blue Player", 640, 150, BLUE);
		textout_centre(victory, tahoma, "Money spent:", 280, 180, LBROWN);
		textprintf_centre(victory, tahoma, 400, 180, LBROWN, "%i$", moneySpent[0]);
		textprintf_centre(victory, tahoma, 640, 180, LBROWN, "%i$", moneySpent[1]);
		textout_centre(victory, tahoma, "Units built:", 280, 210, LBROWN);
		textprintf_centre(victory, tahoma, 400, 210, LBROWN, "%i", unitsBuilt[0]);
		textprintf_centre(victory, tahoma, 640, 210, LBROWN, "%i", unitsBuilt[1]);
		textout_centre(victory, tahoma, "Units killed:", 280, 240, LBROWN);
		textprintf_centre(victory, tahoma, 400, 240, LBROWN, "%i", unitsKilled[0]);
		textprintf_centre(victory, tahoma, 640, 240, LBROWN, "%i", unitsKilled[1]);
		textout_centre(victory, tahoma, "Attacks:", 280, 270, LBROWN);
		textprintf_centre(victory, tahoma, 400, 270, LBROWN, "%i", attacks[0]);
		textprintf_centre(victory, tahoma, 640, 270, LBROWN, "%i", attacks[1]);
		textout_centre(victory, tahoma, "Damage Caused (in $):", 280, 300, LBROWN);
		textprintf_centre(victory, tahoma, 400, 300, LBROWN, "%i$", damageInMoney[0]);
		textprintf_centre(victory, tahoma, 640, 300, LBROWN, "%i$", damageInMoney[1]);
		textout_centre(victory, tahoma, "Fields moved:", 280, 330, LBROWN);
		textprintf_centre(victory, tahoma, 400, 330, LBROWN, "%i", fieldsMoved[0]);
		textprintf_centre(victory, tahoma, 640, 330, LBROWN, "%i", fieldsMoved[1]);
		title(victory, 36, 0);
		destroy_bitmap(victory);
		mouseUpdate();
	//Die Statistik soll immer angezeigt werden
#if 0
	};
#endif

	destroy_bitmap(tiles);
	destroy_bitmap(info);
	destroy_bitmap(margin);
	destroy_bitmap(lifebar);
	destroy_bitmap(bigLifebar);
	pList.stop();
};
