////////////////////////////////////////
// Wars Errordatei, zur Fehlerausgabe //
////////////////////////////////////////

#include "StdHeaders.h"

//Wechselt zwischen Vollbild und Fenstermodus
void changemode(int &curmode)
{
	if(curmode == GFX_AUTODETECT_WINDOWED)
	{
		if(set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0 < 0) < 0)
			Error001();
		curmode = GFX_AUTODETECT_FULLSCREEN;
	}
	else
	{
		if(set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0) < 0)
			Error001();
		curmode = GFX_AUTODETECT_WINDOWED;
	};
};

//Fehler bei set_gfx_mode()
void Error001()
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
    allegro_message("Error001: Couldn't set graphic mode");
    exit(0);
};

//Fehler bei create_bitmap()
void Error002(BITMAP *createdBitmap)
{
	if(!createdBitmap)
	{
		set_gfx_mode(GFX_TEXT, 0,0,0,0);
		allegro_message("Error002: Couldn't create bitmap");
		exit(0);
	};
};

//Fehler bei load_bitmap()
void Error003(char *bitmap)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
    allegro_message("Error003: load_bitmap for \"%s\" failed", bitmap);
    exit(0);
};

//Fehler bei load_wav()
void Error004(char *wav)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
    allegro_message("Error004: load_wav for \"%s\" failed", wav);
    exit(0);
};

//Fehler bei load_datafile()
void Error005(char *datafile)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
    allegro_message("Error005: load_datafile for \"%s\" failed", datafile);
    exit(0);
};

void Error010(char *mapname)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
	allegro_message("Error010: Map \"%s\" was not found", mapname);
	exit(0);
};

void Error011(char *midname)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
	allegro_message("Error011: Midi file \"%s\" could not be loaded", midname);
	exit(0);
};

BITMAP *load_bitmap(char *bitmap)
{
	char stringBuffer[50];
	sprintf(stringBuffer, "GFX/%s", bitmap);
	BITMAP *pointer = load_bitmap(stringBuffer, NULL);
	if(!pointer)
		Error003(stringBuffer);
	return pointer;
};

BITMAP *load_bitmap(const char *bitmap)
{
	char stringBuffer[50];
	sprintf(stringBuffer, "GFX/%s", bitmap);
	BITMAP *pointer = load_bitmap(stringBuffer, NULL);
	if(!pointer)
		Error003(stringBuffer);
	return pointer;
};

void blit(BITMAP *source, BITMAP *dest, int dest_x, int dest_y, int width, int height)
{
	blit(source, dest, 0, 0, dest_x, dest_y, width, height);
};

void blit(BITMAP *source, BITMAP *dest, int width, int height)
{
	blit(source, dest, 0, 0, width, height);
};

void blit(BITMAP *source, BITMAP *dest)
{
	blit(source, dest, SCREEN_W, SCREEN_H);
};

BITMAP *create_bitmap()
{
	BITMAP *buffer = create_bitmap(SCREEN_W, SCREEN_H);
	Error002(buffer);
	return buffer;
};