#ifndef WARS_MAP_CLASS
#define WARS_MAP_CLASS

#include "StdHeaders.h"

class map
{
private:
	int w, h;
	char *data;
	BITMAP *tiles, *dest;
	int tileWidth;
	int tileHeight;
	int size;
	int visibleTilesX, visibleTilesY;
	int maxX, maxY;

	inline void drawTile(int x, int y, int tile);
	void		create(int w, int h);

public:
	map() : w(0), h(0), data(NULL), tiles(NULL), size(0),
            dest(NULL), visibleTilesX(0), visibleTilesY(0)
	{
	};
	map(int w, int h);
	map(int w, int h, char *mapString, char *tileStr);
	map(char *mapName);
	virtual ~map();

	int getTileWidth();
	int getTileHeight();

	int getWidth();
	int getHeight();

	int getMaxX();
	int getMaxY();

	void addMoney(int *money, int player, int moneyPerHouse);

	void   setTargetBitmap(BITMAP *dest);
	BITMAP *getTargetBitmap();

	int  getTileAt(int tileX, int tileY);
	void setTileAt(int tileX, int tileY, int tile);

	//Gibt zurck, wie viele Felder der entsprechende Einheitentyp auf dem Feld gehen kann
	int isWalkable(int tileX, int tileY, int type);
	//Gibt Verteidigungswert des Tiles zurck
	int getDefense(int tileX, int tileY);
	//Gibt den Namen des Feldes zurck
	char *getName(int tileX, int tileY);

	void setTiles(BITMAP *tiles, int tw, int th);
	void draw(int wx, int wy);
};

#endif
