///////////////////////////////////////////
// Klasse zum abspielen aller midi files //
///////////////////////////////////////////

#include "StdHeaders.h"

playlist::playlist()
{
	ifstream plFile("playlist.txt");
	curTitle = 0;
	playing = 0;
	plFile >> LIMIT;
	plFile.ignore(2, '\n');
	titles = new MIDI*[LIMIT];

	for(int i = 0; i < LIMIT; ++i)
	{
		titles[i] = NULL;
		char charBuffer[100];
		plFile.getline(charBuffer, 99);
		titles[i] = load_midi(charBuffer);
		if(!titles[i])
			Error011(charBuffer);
	};

	plFile.close();
};

playlist::~playlist()
{
	for(int i = 0; i < LIMIT; ++i)
	{
		destroy_midi(titles[i]);
	};
	delete [] titles;
};

void playlist::check()
{
	if(playing && midi_pos < 0)
	{
		next();
	};
};

void playlist::play()
{
	if(!playing)
		play_midi(titles[curTitle], 0);
	playing = 1;
};

void playlist::stop()
{
	stop_midi();
	playing = 0;
};

void playlist::next()
{
	++curTitle;
	if(curTitle >= LIMIT)
		curTitle = 0;
	if(playing)
	{
		stop();
		play();
	};
};

void playlist::previous()
{
	--curTitle;
	if(curTitle < 0)
		curTitle = LIMIT - 1;
	if(playing)
	{
		stop();
		play();
	};
};

int playlist::getCurTitle()
{
	return curTitle;
};
