////////////////////////////////////
// Wars Unit Klasse fr Einheiten //
////////////////////////////////////

#include "unit.h"

const int moveType[7] = { 4, 3, 8, 6, 5, 6, 5 };
							//// Militia Warri Scout  Catap Knigh Catapu Trebuchet
const float damageMilitia [7] = {  55.0, 45.0,  12.0,  5.0,  1.0,  15.0,  25.0 }; // Infanterie
const float damageWarrior [7] = {  65.0, 55.0,  85.0, 55.0, 15.0,  70.0,  85.0 }; // Kmpfer
const float damageScout   [7] = {  70.0, 65.0,  35.0,  6.0,  1.0,  45.0,  55.0 }; // Spher
const float damageCataphra[7] = {  75.0, 70.0,  85.0, 55.0, 15.0,  70.0,  85.0 }; // Panzerreiter
const float damageKnight  [7] = { 105.0, 95.0, 105.0, 85.0, 55.0, 105.0, 105.0 }; // Ritter
const float damageCatapult[7] = {  90.0, 85.0,  80.0, 70.0, 45.0,  75.0,  80.0 }; // Katapult
const float damageTrebuche[7] = {  95.0, 90.0,  90.0, 80.0, 55.0,  80.0,  85.0 }; // Trebuchet
const float *damageType[7] = { damageMilitia, damageWarrior, damageScout, damageCataphra, damageKnight, damageCatapult, damageTrebuche };

unit::unit(int x, int y, int type, int friendfoe)
{
	this->x = x;
	this->y = y;
	this->type = type;
	this->friendfoe = friendfoe;
	this->alife = 1;
	this->life = 100;
	this->movePoints = moveType[type];
	this->hasAttacked = 0;
};

void unit::initialise(int x, int y, int type, int friendfoe)
{
	this->x = x;
	this->y = y;
	this->type = type;
	this->friendfoe = friendfoe;

	hasAttacked = 1;
	movePoints = 0;

	alife = 1;
	life = 100;
};

void unit::getPos(int *containerX, int *containerY)
{
	*containerX = x;
	*containerY = y;
};

void unit::setPos(int newx, int newy)
{
	x = newx;
	y = newy;
};

int unit::isAlife()
{
	return alife;
};

int unit::getLife()
{
	return life;
};

void unit::setLife(int newLife)
{
	life = newLife;
	if(life <= 0)
		this->kill();
};

void unit::setBitmap(BITMAP *destination)
{
	dest = destination;
};

void unit::draw(int curX, int curY, const int tile_h, const int tile_w)
{
	if(alife && x >= curX && x <= curX + 20 && y >= curY && y <= curY + 11)
		masked_blit(sprites[friendfoe][type], doubleBuffer, 0, 0, (x - curX) * tile_w, (y - curY) * tile_h, 40, 40);
};

void unit::drawLife(int curX, int curY, const int tile_h, const int tile_w, BITMAP *lifebar)
{
	if(alife && x >= curX && x <= curX + 19 && y >= curY && y <= curY + 10)
	{
		float drawWidth = (float) life * 0.4;
		masked_blit(lifebar, doubleBuffer, 0, 0, (x - curX) * tile_w, (y - curY) * tile_h + 36, (int) drawWidth, 4);
	};
};

void unit::kill()
{
	alife = 0;
	life = 0;
	x = -1;
	y = -1;
	movePoints = -1;
	friendfoe = -1;
	type = -1;
	hasAttacked = 1;
};

int unit::getFriendfoe()
{
	return friendfoe;
};

int unit::getGroup()
{
	if(type < 2)
		return INFANTRY;
	if(type < 5)
		return KAVALLRY;
	return ARTILLRY;
};

int unit::getType()
{
	return type;
};

int unit::getMovePoints()
{
	return movePoints;
};

void unit::endRound()
{
	if(alife)
	{
		movePoints = moveType[type];
		hasAttacked = 0;
	};
};

void unit::substractMovePoints(int points)
{
	movePoints -= points;
};

void unit::killMovePoints()
{
	movePoints = 0;
};

int unit::getX()
{
	return x;
};

int unit::getY()
{
	return y;
};

void unit::attack()
{
	hasAttacked = 1;
};

int unit::canAttack()
{
	return hasAttacked ^ 1;
};

void unit::substractLife(int value)
{
	life -= value;
	if(life <= 0)
		this->kill();
};
