#ifndef WARS_UNIT_CLASS
#define WARS_UNIT_CLASS

#include "StdHeaders.h"

#define addLife(nlf) substractLife(-nlf)

extern const int moveType[7];
extern const float *damageType[7];

class unit
{
private:
	//Lebt die Einheit berhaupt?
	int alife;

	//Lebenspunkte
	int life;

	//Bewegungspunkte
	int movePoints;

	//Hat die Einheit schon angegriffen?
	int hasAttacked;

	//Position
	int x, y;

	//Einheitentyp
	int type;

	//Zugehrigkeit 0 = Spieler 1, 1 = Spieler 2
	int friendfoe;

	//Zielbitmap
	BITMAP *dest;

public:
	unit() : alife(0), life(0), x(-1), y(-1), type(-1), friendfoe(-1), movePoints(-1), hasAttacked(1)
	{
/*		alife = 0;
		life = 0;
		x = -1;
		y = -1;
		type = -1;
		friendfoe = -1;
		movePoints = -1;
		hasAttacked = 1;*/
	};

	unit(int x, int y, int type, int friendfoe);

	~unit() {};

	int getFriendfoe();
	int getType();
	int getGroup();
	int getMovePoints();

	void substractMovePoints(int points);
	void killMovePoints();

	void kill();

	void endRound();

	void initialise(int x, int y, int type, int friendfoe);

	int isAlife();

	void setBitmap(BITMAP *destination);

	void getPos(int *x, int *y);
	int getX();
	int getY();
	void setPos(int newx, int newy);

	int getLife();
	void setLife(int newLife);
	void substractLife(int value);

	void attack();
	int canAttack();

	void draw(int curX, int curY, const int tile_h, const int tile_w);

	void drawLife(int curX, int curY, const int tile_h, const int tile_w, BITMAP *lifebar);
};

#endif